RSCreateEditor	Proto :HWND, :DWord, :DWord, :LONG, :LONG, :LONG, :LONG, :LONG, :BOOL

.Const

.Data?

szLeft				Byte		32 Dup(? )
szTop				Byte		32 Dup(? )
szWidth				Byte		32 Dup(? )
szHeight			Byte		32 Dup(? )
ssKeyboardState		Byte		256 Dup(? )

.Data

szFileName			Word		MAX_PATH Dup(0)
szBuffer			Word		MAX_PATH Dup(0)

bRecordingMacro		BOOL		FALSE
bUntitled			BOOL		TRUE
lFilterOpen			LONG		1
lFilterSave			LONG		1
lMacroCount			LONG		0
hWndToolBar			HWND		NULL
hWndStatusBar		HWND		NULL
hWndToolTips		HWND		NULL

lpMacroContent		LPLONG		NULL
lpUCaseTableA		LPLONG		NULL
lpUCaseTableW		LPLONG		NULL

include ECProtos.inc ; .Code

ProcessMessages Proc hWnd:DWord, uMsg:DWord, wParam:DWord, lParam:DWord
	Local msg:MSG

	.If hWndEditor
		.If bRecordingMacro
			.If uMsg == WM_KEYDOWN || uMsg == WM_CHAR || uMsg == WM_KEYUP
				Invoke RSRecordMacro, hWnd, uMsg, wParam, lParam
			.EndIf
		.ElseIf bPlayingMacro
			Mov Eax, hWnd
			Mov msg.hwnd, Eax
			Mov Eax, uMsg
			Mov msg.message, Eax
			Mov Eax, wParam
			Mov msg.wParam, Eax
			Mov Eax, lParam
			Mov msg.lParam, Eax
			Invoke ECLibTranslateAccelerator, App.Main, App.Accel, Addr msg
			.If (!Eax)
				Invoke TranslateMessage, Addr msg
				Invoke ECLibDispatchMessage, Addr msg
			.EndIf
			Mov Eax, TRUE
			Jmp @F
		.EndIf
	.EndIf
	Xor Eax, Eax
@@:	Ret
ProcessMessages EndP

EditorProcedure Proc Private Uses Edi Esi hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local uiID:UINT, rc:RECT
	Local chr:RSSCHARSEL

	.If uMsg == WM_NCCREATE
		Invoke IsAppUnicode
		Mov bAppUnicode, Eax
		Invoke GetRightFormatText, Addr szRegistryKey, TextAddr("Software\RSC Products\Editor\Settings")
		Invoke GetRightFormatText, Addr szAutoIndent, TextAddr("AutoIndent")
		Invoke GetRightFormatText, Addr szBOM, TextAddr("B.O.M.")
		Invoke GetRightFormatText, Addr szHideSelBar, TextAddr("HideSelBar")
		Invoke GetRightFormatText, Addr szHideSelection, TextAddr("HideSelection")
		Invoke GetRightFormatText, Addr szEndOfLine, TextAddr("EndOfLine")
		Invoke GetRightFormatText, Addr szTabSize, TextAddr("TabSize")
		Invoke GetRightFormatText, Addr szTabToSpaces, TextAddr("TabToSpaces")
		Invoke GetRightFormatText, Addr szSpacesToTab, TextAddr("SpacesToTab")
		Invoke GetRightFormatText, Addr szToolbar, TextAddr("Toolbar")
		Invoke GetRightFormatText, Addr szStatusbar, TextAddr("Statusbar")
		Invoke GetRightFormatText, Addr szBackColor, TextAddr("BackColor")
		Invoke GetRightFormatText, Addr szTextColor, TextAddr("TextColor")
		Invoke GetRightFormatText, Addr szSelBarColor, TextAddr("SelBarColor")
		Invoke GetRightFormatText, Addr szBackSelect, TextAddr("BackSelect")
		Invoke GetRightFormatText, Addr szTextSelect, TextAddr("TextSelect")
		Invoke GetRightFormatText, Addr szBackLocked, TextAddr("BackLocked")
		Invoke GetRightFormatText, Addr szTextLocked, TextAddr("TextLocked")
		Invoke GetRightFormatText, Addr szFontPoints, TextAddr("FontPoints")
		Invoke GetRightFormatText, Addr szFontWeight, TextAddr("FontWeight")
		Invoke GetRightFormatText, Addr szFontItalic, TextAddr("FontItalic")
		Invoke GetRightFormatText, Addr szFontStrikethru, TextAddr("FontStrikethru")
		Invoke GetRightFormatText, Addr szFontUnderline, TextAddr("FontUnderline")
		Invoke GetRightFormatText, Addr szFontCharSet, TextAddr("FontCharSet")
		Invoke GetRightFormatText, Addr szFontName, TextAddr("FontName")
		Invoke GetRightFormatText, Addr szLastPath, TextAddr("LastPath")

		Invoke GetRightFormatText, Addr szLeft, TextAddr("Left")
		Invoke GetRightFormatText, Addr szTop, TextAddr("Top")
		Invoke GetRightFormatText, Addr szWidth, TextAddr("Width")
		Invoke GetRightFormatText, Addr szHeight, TextAddr("Height")

		Mov Eax, (65536 * 2 + 256)
		Invoke VirtualAlloc, 0, Eax, MEM_COMMIT, PAGE_READWRITE
		Mov lpUCaseTableA, Eax
		Add Eax, 256
		Mov lpUCaseTableW, Eax
		Invoke VirtualAlloc, 0, 1048576, MEM_COMMIT, PAGE_READWRITE
		Mov lpMacroContent, Eax

	.ElseIf uMsg == WM_CREATE
		Invoke RSCreateEditor, hWnd, (WS_CHILD OR WS_VISIBLE OR WS_CLIPCHILDREN OR WS_HSCROLL OR WS_VSCROLL OR RSS_SPLIT), (WS_EX_CLIENTEDGE OR WS_EX_ACCEPTFILES), 0, 0, 0, 0, 0, bAppUnicode
		Mov hWndEditor, Eax
		Invoke GetWindowLong, hWndEditor, GWL_WNDPROC
		Invoke SetWindowLong, hWndEditor, GWL_USERDATA, Eax
		Invoke SetWindowLong, hWndEditor, GWL_WNDPROC, Addr RSEditorWndProc


		Invoke GlobalAlloc, GPTR, (MAX_PATH * 4)
		Mov lpszCommon, Eax

		Invoke SendMessage, hWndEditor, RSM_SETCHARPROCADDRESS, 0, Addr IsCharAlphaProc

		Invoke GetWindowItem, hWnd, IDC_EDITOR_STATUSBAR1
		Mov hWndStatusBar, Eax
		Invoke GetWindowItem, hWnd, IDC_EDITOR_TOOLBAR1
		Mov hWndToolBar, Eax
		Invoke RSSendMessage, Eax, TB_GETTOOLTIPS, 0, 0
		Mov hWndToolTips, Eax

		Invoke GetRegistrySettings
		Invoke SetVisible, hWndToolBar, Cfg.bToolbar
		Invoke CheckMenu, IDM_EDITOR_TOOLBAR, Cfg.bToolbar
		Invoke SetVisible, hWndStatusBar, Cfg.bStatusbar
		Invoke SendMessage, hWndEditor, RSM_SETHIDEGRIP, Cfg.bStatusbar, 0
		Invoke CheckMenu, IDM_EDITOR_STATUSBAR, Cfg.bStatusbar
		Invoke SetEditorSettings, TRUE, TRUE
		Invoke SetStatusBar

		Lea Eax, Cfg.szLastPath
		Push Eax
		Push lpszCommon
		.If bAppUnicode
			Mov Eax, lstrcpyW
		.Else
			Mov Eax, lstrcpyA
		.EndIf
		Call Eax
		Push lpszCommon
		.If bAppUnicode
			Mov Eax, lstrlenW
		.Else
			Mov Eax, lstrlenA
		.EndIf
		Call Eax
		.If (Eax > SDWord Ptr 0)
			Dec Eax
		.EndIf
		.If bAppUnicode
			Shl Eax, 1
		.EndIf
		Add Eax, lpszCommon
		.If bAppUnicode
			.If Word Ptr [Eax] == '\'
				Mov Word Ptr [Eax], 0
			.EndIf
		.Else
			.If Byte Ptr [Eax] == '\'
				Mov Byte Ptr [Eax], 0
			.EndIf
		.EndIf
		Invoke FileExists, lpszCommon, TRUE
		.If Eax == (-1)
			Invoke RSGetCurrentDirectory, MAX_PATH, Addr Cfg.szLastPath
		.EndIf

		Invoke SendMessage, hWndEditor, RSM_SETEVENTMASK, (RSV_CHANGE OR RSV_SELCHANGE), 0
		Invoke RSLoadString, App.Instance, IDS_UNTITLED, Addr szFileName, MAX_PATH
		Invoke SetAppCaption, TRUE

		Invoke GetWindowRect, hWnd, Addr rc
		Mov Ecx, rc.right
		Sub Ecx, rc.left
		Mov Edx, rc.bottom
		Sub Edx, rc.top

		Invoke String, rc.left, lpszCommon, ecDecimal
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLeft, lpszCommon
		Invoke Value, lpszCommon
		Mov rc.left, Eax
		Invoke String, rc.top, lpszCommon, ecDecimal
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTop, lpszCommon
		Invoke Value, lpszCommon
		Mov rc.top, Eax

		Invoke String, Ecx, lpszCommon, ecDecimal
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szWidth, lpszCommon
		Invoke Value, lpszCommon
		Mov rc.right, Eax
		Invoke String, Edx, lpszCommon, ecDecimal
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHeight, lpszCommon
		Invoke Value, lpszCommon
		Mov rc.bottom, Eax
		Invoke MoveWindow, hWnd, rc.left, rc.top, rc.right, rc.bottom, TRUE

		Mov Edi, App.CommandLine
		Mov Ax, Word Ptr [Edi]
		.If (!bAppUnicode)
			Xor Ah, Ah
		.EndIf
		.If Ax
			Push Eax
			Invoke ShowWindow, hWnd, SW_SHOWNORMAL
			Invoke UpdateWindow, hWnd
			Pop Eax
			.If Ax == '"'
				Inc Edi
				.If bAppUnicode
					Inc Edi
				.EndIf
			.EndIf
			Invoke FindCharRev, Edi, '\'
			.If Eax == (-1)
				Invoke RSlstrcpy, Addr szFileName, Edi
			.Else
				Inc Eax
				Push Eax
				Invoke RSlstrcpyn, Addr Cfg.szLastPath, Edi, Eax
				Pop Eax
				.If bAppUnicode
					Shl Eax, 1
				.EndIf
				Add Edi, Eax
				Invoke RSlstrcpy, Addr szFileName, Edi
			.EndIf
			Invoke RSlstrlen, Addr szFileName
			.If bAppUnicode
				Shl Eax, 1
			.EndIf
			Add Eax, Offset szFileName
			Mov Edx, Eax
			Dec Edx
			.If bAppUnicode
				Dec Edx
				Mov Ax, Word Ptr [Edx]
			.Else
				Xor Ah, Ah
				Mov Al, Byte Ptr [Edx]
			.EndIf
			.If (Ax == '"')
				Mov Word Ptr [Edx], 0
			.EndIf
			Invoke LoadFile
		.EndIf
L2:		Xor Eax, Eax
		Jmp L6

	.ElseIf uMsg == WM_SETFOCUS
		.If hWndEditor
			Invoke SetFocus, hWndEditor
			Invoke EnableSelChangeMenus
			Invoke EnableChangeMenus
		.EndIf
L4:		Mov Eax, TRUE
		Jmp L6

	.ElseIf uMsg == WM_NOTIFY
		Mov Ebx, lParam
		.If ([Ebx].NMHDR.code == TTN_NEEDTEXT || [Ebx].NMHDR.code == TTN_NEEDTEXTW)
			Mov Eax, [Ebx].NMHDR.hwndFrom
			.If Eax == hWndToolTips
				Mov Esi, lParam
				.If [Esi].TOOLTIPTEXT.hdr.idFrom == 1
					Mov uiID, IDS_NEW
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 2
					Mov uiID, IDS_OPEN2
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 3
					Mov uiID, IDS_SAVE
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 5
					Mov uiID, IDS_UNDO
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 6
					Mov uiID, IDS_REDO
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 8
					Mov uiID, IDS_CUT
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 9
					Mov uiID, IDS_COPY
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 10
					Mov uiID, IDS_PASTE
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 11
					Mov uiID, IDS_DELETE
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 13
					Mov uiID, IDS_FIND2
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 15
					Mov uiID, IDS_ADD_INDENT
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 16
					Mov uiID, IDS_REMOVE_INDENT
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 18
					Mov uiID, IDS_TOGGLE_BOOKMARK
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 19
					Mov uiID, IDS_NEXT_BOOKMARK
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 20
					Mov uiID, IDS_PREV_BOOKMARK
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 21
					Mov uiID, IDS_CLEAR_BOOKMARKS
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 23
					Mov uiID, IDS_START_RECORDING
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 24
					Mov uiID, IDS_STOP_RECORDING
				.ElseIf [Esi].TOOLTIPTEXT.hdr.idFrom == 25
					Mov uiID, IDS_PLAYBACK
				.Else
					Mov uiID, 0
				.EndIf
				Mov Eax, uiID
				Mov [Esi].TOOLTIPTEXT.lpszText, Eax
				Mov Eax, App.Instance
				Mov [Esi].TOOLTIPTEXT.hinst, Eax
			.EndIf
			Assume Ebx:Nothing
		.ElseIf [Ebx].NMHDR.code == EN_SELCHANGE
			.If hWndSearch
				Invoke RSSendMessage, hWndSearch, EM_CHANGESELECTION, 0, 0
			.EndIf
			Invoke SetStatusBar
			Invoke EnableSelChangeMenus
		.EndIf

	.ElseIf uMsg == WM_INITMENUPOPUP
		Invoke GetMenu, hWnd
		Invoke GetSubMenu, Eax, 3
		.If Eax == wParam
			Invoke SetEncodingMenu, Eax
		.EndIf

	.ElseIf uMsg == WM_COMMAND
		LoWord wParam
		.If lParam
			Mov Edi, lParam
			.If Edi == hWndToolBar
				Push Eax
				Mov Ecx, Eax
				Dec Ecx
				Invoke RSSendMessage, hWndToolBar, TB_GETITEMRECT, Ecx, Addr rc
				Invoke InvalidateRect, hWndToolBar, Addr rc, FALSE
				Pop Eax
				.If Ax == 1
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_NEW, 0
					Jmp L4
				.ElseIf Ax == 2
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_OPEN, 0
					Jmp L4
				.ElseIf Ax == 3
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_SAVE, 0
					Jmp L4
				.ElseIf Ax == 5
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_UNDO, 0
					Jmp L4
				.ElseIf Ax == 6
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_REDO, 0
					Jmp L4
				.ElseIf Ax == 8
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_CUT, 0
					Jmp L4
				.ElseIf Ax == 9
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_COPY, 0
					Jmp L4
				.ElseIf Ax == 10
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_PASTE, 0
					Jmp L4
				.ElseIf Ax == 11
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_DELETE, 0
					Jmp L4
				.ElseIf Ax == 13
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_FIND, 0
					Jmp L4
				.ElseIf Ax == 15
					Invoke SendMessage, hWndEditor, RSM_SETINDENT, FALSE, 0
					Jmp L4
				.ElseIf Ax == 16
					Invoke SendMessage, hWndEditor, RSM_SETINDENT, TRUE, 0
					Jmp L4
				.ElseIf Ax == 18
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_TOGGLE, 0
					Jmp L4
				.ElseIf Ax == 19
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_NEXT_BOOKMARK, 0
					Jmp L4
				.ElseIf Ax == 20
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_PREV_BOOKMARK, 0
					Jmp L4
				.ElseIf Ax == 21
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_CLEAR, 0
					Jmp L4
				.ElseIf Ax == 23
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_START_RECORDING, 0
					Jmp L4
				.ElseIf Ax == 24
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_STOP_RECORDING, 0
					Jmp L4
				.ElseIf Ax == 25
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_PLAYBACK, 0
					Jmp L4
				.EndIf
			.ElseIf Edi == hWndEditor
				HiWord wParam
				.If Ax == EN_CHANGE
					Invoke EnableChangeMenus
				.ElseIf Ax == EN_SETFOCUS
					Invoke EnableSelChangeMenus
				.EndIf
			.EndIf
		.Else
			.If Ax == IDM_EDITOR_NEW
				Invoke FileChanged
				Or Eax, Eax
				Jnz L6
				Invoke RSLoadString, App.Instance, IDS_UNTITLED, Addr szFileName, MAX_PATH
				Invoke SetAppCaption, TRUE
				Invoke SendMessage, hWndEditor, WM_SETTEXT, 0, NULL
				Mov bUntitled, TRUE
				Invoke SendMessage, hWndEditor, RSM_ISTEXTUNICODELE, 0, 0
				Mov bTextUnicode, Eax
				Invoke EnableSelChangeMenus
				Invoke EnableChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_OPEN
				Invoke FileChanged
				Or Eax, Eax
				Jnz L6
				Invoke GetCommonDialogBox, TRUE
				Mov Esi, Eax
				Invoke SetWaitCursor, hWnd
				.If Esi
					Invoke LoadFile
				.EndIf
				Invoke EnableChangeMenus
				Invoke EnableSelChangeMenus
				Invoke SetDefaultCursor
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_SAVE || Ax == IDM_EDITOR_SAVE_AS
				Mov Esi, Eax
				Invoke SendMessage, hWndEditor, EM_GETMODIFY, 0, 0
				.If Eax || Esi == IDM_EDITOR_SAVE_AS
					Invoke EnableToolBarButton, 3, FALSE
					Invoke SetWaitCursor, hWnd
					Mov Eax, TRUE
					.If bUntitled || Esi == IDM_EDITOR_SAVE_AS
						Invoke GetCommonDialogBox, FALSE
					.EndIf
					.If Eax
						Invoke GlobalAlloc, GPTR, (MAX_PATH * 2)
						Mov Esi, Eax
						Invoke RSlstrcpy, Esi, Addr Cfg.szLastPath
						Invoke MakeFullPath, Esi, Addr szFileName
						Invoke SendMessage, hWndEditor, RSM_SAVEFILE, lFilterSave, Esi
						Invoke GlobalFree, Esi
						Invoke SetAppCaption, FALSE
						Invoke SendMessage, hWndEditor, RSM_ISTEXTUNICODELE, 0, 0
						Mov bTextUnicode, Eax
					.EndIf
					Invoke SetDefaultCursor
				.EndIf
				Invoke EnableChangeMenus
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_EXIT
				Invoke RSSendMessage, hWnd, WM_CLOSE, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_UNDO
				Invoke SendMessage, hWndEditor, EM_UNDO, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_REDO
				Invoke SendMessage, hWndEditor, EM_REDO, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_CUT
				Invoke SendMessage, hWndEditor, WM_CUT, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_COPY
				Invoke SendMessage, hWndEditor, WM_COPY, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_PASTE
				Invoke SendMessage, hWndEditor, WM_PASTE, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_DELETE
				Invoke SendMessage, hWndEditor, WM_KEYDOWN, VK_DELETE, lParam
				Invoke EnableChangeMenus
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_SELECT_ALL
				Invoke SendMessage, hWndEditor, RSM_SELECTALLTEXT, 0, 0
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_FIND
				.If hWndSearch
					Invoke RSSendMessage, hWndSearch, EM_SHOWFINDWINDOW, 0, FALSE
				.Else
					Invoke GetRightFormatText, lpszCommon, TextAddr("Search")
					Invoke Create, lpszCommon, hWnd, ecModeless, FALSE
					Mov hWndSearch, Eax
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_FIND_NEXT
				.If hWndSearch
					Invoke FindNextText, hWndSearch, TRUE, TRUE
				.Else
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_FIND, 0
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_FIND_PREV
				.If hWndSearch
					Invoke FindNextText, hWndSearch, FALSE, TRUE
				.Else
					Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_FIND, 0
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_PLAYBACK
				.If hWndEditor != NULL && lpMacroContent != NULL
					Mov lMacroTimes, 1
					Invoke RunMacro
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_RUN_MULTIPLE_TIMES
				.If hWndEditor != NULL && lpMacroContent != NULL
					Invoke Create, TextStr("Macros"), hWnd, ecModal, NULL
					.If Eax == IDOK
						Invoke RunMacro
					.EndIf
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_START_RECORDING
				.If hWndEditor != NULL
					Invoke RtlZeroMemory, lpMacroContent, 1048576
					Mov lMacroCount, 0
					Mov bRecordingMacro, TRUE
					Invoke EnableChangeMenus
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_STOP_RECORDING
				Mov bRecordingMacro, FALSE
				Mov lMacroCount, 0
				Mov lMacroTimes, 0
				Invoke EnableChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_REPLACE
				.If hWndSearch
					Invoke RSSendMessage, hWndSearch, EM_SHOWFINDWINDOW, 0, TRUE
				.Else
					Invoke GetRightFormatText, lpszCommon, TextAddr("Search")
					Invoke Create, lpszCommon, hWnd, ecModeless, TRUE
					Mov hWndSearch, Eax
				.EndIf
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_GOTO_LINE
				Invoke GetRightFormatText, lpszCommon, TextStrA("GotoLine")
				Invoke Create, lpszCommon, hWnd, ecModal, 0
				Jmp L2

			.ElseIf Ax == IDM_EDITOR_TOGGLE
				Invoke SendMessage, hWndEditor, RSM_TOGGLEBOOKMARK, 0, 0
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_NEXT_BOOKMARK
				Invoke SendMessage, hWndEditor, RSM_GOTONEXTBOOKMARK, 0, 0
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_PREV_BOOKMARK
				Invoke SendMessage, hWndEditor, RSM_GOTOPREVBOOKMARK, 0, 0
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_CLEAR
				Invoke SendMessage, hWndEditor, RSM_CLEARBOOKMARKS, 0, 0
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_LOCK
				Invoke SendMessage, hWndEditor, RSM_GETSELECTION, Addr chr.lMin, Addr chr.lMax
				Mov Eax, chr.lMax
				Cmp Eax, chr.lMin
				Je @F
				Dec Eax
				Mov chr.lMax, Eax
@@:				Invoke SendMessage, hWndEditor, EM_LINEFROMCHAR, chr.lMin, 0
				Mov Edi, Eax
				Invoke SendMessage, hWndEditor, EM_LINEFROMCHAR, chr.lMax, 0
				Invoke SendMessage, hWndEditor, RSM_LOCKLINES, Edi, Eax
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_UNLOCK
				Invoke SendMessage, hWndEditor, RSM_GETSELECTION, Addr chr.lMin, Addr chr.lMax
				Mov Eax, chr.lMax
				Cmp Eax, chr.lMin
				Je @F
				Dec Eax
				Mov chr.lMax, Eax
@@:				Invoke SendMessage, hWndEditor, EM_LINEFROMCHAR, chr.lMin, 0
				Mov Edi, Eax
				Invoke SendMessage, hWndEditor, EM_LINEFROMCHAR, chr.lMax, 0
				Invoke SendMessage, hWndEditor, RSM_UNLOCKLINES, Edi, Eax
				Invoke EnableSelChangeMenus
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_TOOLBAR
				Invoke GetClientRect, hWnd, Addr rc
				Invoke GetVisible, hWndToolBar
				Xor Eax, 1
				Mov Cfg.bToolbar, Eax
				Invoke SetVisible, hWndToolBar, Eax
				Invoke CheckMenu, IDM_EDITOR_TOOLBAR, Cfg.bToolbar
				Invoke String, Cfg.bToolbar, lpszCommon, ecDecimal
				Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szToolbar, lpszCommon
				Mov Eax, rc.bottom
				Shl Eax, 16
				Or Eax, rc.right
				Invoke RSSendMessage, hWnd, WM_SIZE, 0, Eax
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_STATUSBAR
				Invoke GetClientRect, hWnd, Addr rc
				Invoke GetVisible, hWndStatusBar
				Xor Eax, 1
				Mov Cfg.bStatusbar, Eax
				Invoke SendMessage, hWndEditor, RSM_SETHIDEGRIP, Eax, 0
				Invoke SetVisible, hWndStatusBar, Cfg.bStatusbar
				Invoke CheckMenu, IDM_EDITOR_STATUSBAR, Cfg.bStatusbar
				Invoke String, Cfg.bStatusbar, lpszCommon, ecDecimal
				Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szStatusbar, lpszCommon
				.If Cfg.bStatusbar
					Invoke SetStatusBar
				.EndIf
				Mov Eax, rc.bottom
				Shl Eax, 16
				Or Eax, rc.right
				Invoke RSSendMessage, hWnd, WM_SIZE, 0, Eax
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_SETTINGS
				Invoke GetRightFormatText, lpszCommon, TextAddr("Settings")
				Invoke Create, lpszCommon, hWnd, ecModal, NULL
				Jmp L4

			.ElseIf (Ax == IDM_EDITOR_CONVERT_ANSI || Ax == IDM_EDITOR_CONVERT_UNICODE_BE || Ax == IDM_EDITOR_CONVERT_UNICODE_LE || Ax == IDM_EDITOR_CONVERT_UTF8)
				Push Eax
				Invoke SetWaitCursor, hWnd
				Pop Eax
				.If Ax == IDM_EDITOR_CONVERT_ANSI
					Mov Eax, ANSI_TEXT
				.ElseIf Ax == IDM_EDITOR_CONVERT_UNICODE_BE
					Mov Eax, UNICODE_BE_TEXT
				.ElseIf Ax == IDM_EDITOR_CONVERT_UNICODE_LE
					Mov Eax, UNICODE_LE_TEXT
				.ElseIf Ax == IDM_EDITOR_CONVERT_UTF8
					Mov Eax, UTF_8_TEXT
				.Else
					Jmp L4
				.EndIf
				Invoke SendMessage, hWndEditor, RSM_CONVERTTEXT, Eax, 0
				.If Eax
					Invoke SendMessage, hWndEditor, RSM_ISTEXTUNICODELE, 0, 0
					Mov bTextUnicode, Eax
					Invoke SendMessage, hWndEditor, RSM_GETTEXTFORMAT, 0, 0
					Mov lFilterSave, Eax
					Invoke SetAppCaption, FALSE
					Invoke EnableChangeMenus
					Invoke EnableSelChangeMenus
					Invoke Refresh, hWndEditor
				.EndIf
				Invoke SetDefaultCursor
				Jmp L4

			.ElseIf Ax == IDM_EDITOR_ABOUT
				Invoke GetRightFormatText, lpszCommon, TextAddr("About")
				Invoke Create, lpszCommon, hWnd, ecModal, NULL
				Jmp L4
			.EndIf
		.EndIf

	.ElseIf uMsg == RSM_RBUTTONCLICKED
		Mov Edi, lParam
		Invoke GetMenu, App.Main
		Invoke GetSubMenu, Eax, 1
		Invoke TrackPopupMenu, Eax, (TPM_LEFTALIGN OR TPM_RIGHTBUTTON), [Edi].POINTL.x, [Edi].POINTL.y, 0, hWnd, NULL
		Jmp L2

	.ElseIf uMsg == RSL_GETPLATFORM
		Invoke GetPlatform, NULL
		Jmp L6

	.ElseIf uMsg == RSM_GETUCASETABLES
		Mov Edx, wParam
		.If Edx
			Mov Eax, lpUCaseTableA
			Mov DWord Ptr [Edx], Eax
		.EndIf
		Mov Edx, lParam
		.If Edx
			Mov Eax, lpUCaseTableW
			Mov DWord Ptr [Edx], Eax
		.EndIf
		Jmp L6

	.ElseIf uMsg == RSM_GOTO_LINE
		.If wParam
			Dec wParam
			Invoke SendMessage, hWndEditor, RSM_GETLINECOUNT, 0, 0
			.If Eax >= SDWord Ptr wParam
				Invoke SendMessage, hWndEditor, RSM_GETLINEINDEX, wParam, 0
				Invoke SendMessage, hWndEditor, RSM_SETSELECTION, Eax, Eax
			.EndIf
		.EndIf
		Jmp L6

	.ElseIf uMsg == RSM_SHOWMESSAGEBOX
		.If wParam == RSC_ERRORMEMALLOC
			Mov Eax, IDS_ALLOC_ERROR
		.ElseIf wParam == RSC_ERRORNOMEMORY
			Mov Eax, IDS_NO_MEMORY
		.ElseIf wParam == RSC_ERRORUNICODE
			Mov Eax, IDS_UNICODE_ERROR
		.Else
			Xor Eax, Eax
		.EndIf
		.If Eax
			Invoke RSLoadString, App.Instance, Eax, lpszCommon, MAX_PATH
			Invoke RSMessageBox, App.Main, lpszCommon, App.Header, (MB_OK)
		.EndIf
		Jmp L6

	.ElseIf uMsg == RSM_UPDATEEDITFUNCTIONS
		Invoke RSSendMessage, hWndEditor, RSM_GETEVENTMASK, 0, 0
		.If Eax
			Invoke EnableSelChangeMenus
			.If wParam
				Invoke SetStatusBar
			.EndIf
		.EndIf
		Jmp L6

	.ElseIf uMsg == WM_SIZE
		Xor Ecx, Ecx
		.If Cfg.bToolbar
			Invoke GetWindowRect, hWndToolBar, Addr rc
			Mov Ecx, rc.bottom
			Sub Ecx, rc.top
		.EndIf
		Xor Edx, Edx
		.If Cfg.bStatusbar
			Push Ecx
			Invoke GetWindowRect, hWndStatusBar, Addr rc
			Mov Edx, rc.bottom
			Sub Edx, rc.top
			Pop Ecx
		.EndIf
		HiWord lParam
		Sub Eax, Ecx
		Sub Eax, Edx
		Mov Edx, Eax
		LoWord lParam
		Invoke MoveWindow, hWndEditor, 0, Ecx, Eax, Edx, TRUE

	.ElseIf uMsg == WM_CLOSE
		Invoke FileChanged
		Push Eax
		.If hWndSearch
			Invoke RSSendMessage, hWndSearch, WM_CLOSE, 0, 0F0F0F0F0H
		.EndIf
		Invoke RSGetWindowLong, hWnd, GWL_STYLE
		Test Eax, (WS_MAXIMIZE OR WS_MINIMIZE)
		.If Zero?
			Invoke GetWindowRect, hWnd, Addr rc
			Invoke String, rc.left, lpszCommon, ecDecimal
			Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLeft, lpszCommon
			Invoke GetLastError
			Invoke String, rc.top, lpszCommon, ecDecimal
			Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szTop, lpszCommon
			Mov Eax, rc.right
			Sub Eax, rc.left
			Invoke String, Eax, lpszCommon, ecDecimal
			Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szWidth, lpszCommon
			Mov Eax, rc.bottom
			Sub Eax, rc.top
			Invoke String, Eax, lpszCommon, ecDecimal
			Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szHeight, lpszCommon
		.EndIf
		Pop Eax
		Jmp L6

	.ElseIf uMsg == WM_DESTROY
		Invoke DestroyWindow, hWndEditor
		.If lpUCaseTableA
			Invoke VirtualFree, lpUCaseTableA, 0, MEM_RELEASE
			Mov lpUCaseTableA, NULL
		.EndIf
		.If lpMacroContent != NULL
			Invoke VirtualFree, lpMacroContent, 0, MEM_RELEASE
			Mov lpMacroContent, NULL
		.EndIf
		Invoke GlobalFree, lpszCommon
	.EndIf
	Xor Eax, Eax
L6:	Ret
EditorProcedure EndP

CheckMenu Proc Private uiMenu:UINT, bChecked:BOOL
	Invoke GetMenu, App.Main
	Mov Ebx, Eax
	.If bChecked
		Mov Eax, MF_CHECKED
	.Else
		Mov Eax, MF_UNCHECKED
	.EndIf
	Or Eax, MF_BYCOMMAND
	Invoke CheckMenuItem, Ebx, uiMenu, Eax
	Ret
CheckMenu EndP

DropFiles Proc Private hDrop:HDROP
	Invoke GlobalAlloc, GPTR, (MAX_PATH * 2 + 4)
	Mov Esi, Eax
	Push (MAX_PATH * 2)
	Push Esi
	Push 0
	Push hDrop
	.If bAppUnicode
		Mov Eax, DragQueryFileW
	.Else
		Mov Eax, DragQueryFile
	.EndIf
	Call Eax
	Mov Ebx, Eax
	Invoke DragFinish, hDrop
	.If Ebx
		Invoke GetFileNameAndLoad, Esi
		Invoke GlobalFree, Esi
	.EndIf
	Ret
DropFiles EndP

EnableChangeMenus Proc Private Uses Ebx Edi Esi
	Invoke GetMenu, App.Main
	Mov Ebx, Eax
	Invoke SendMessage, hWndEditor, EM_GETMODIFY, 0, 0
	.If Eax
		Mov Edi, MF_ENABLED
	.Else
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 3, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_SAVE, Edi
	Invoke SendMessage, hWndEditor, EM_CANUNDO, 0, 0
	.If Eax
		Mov Edi, MF_ENABLED
	.Else
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 5, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_UNDO, Edi

	Invoke SendMessage, hWndEditor, EM_CANREDO, 0, 0
	.If Eax
		Mov Edi, MF_ENABLED
	.Else
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 6, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_REDO, Edi

	.If bRecordingMacro
		Xor Esi, Esi
		Mov Edi, MF_GRAYED
	.Else
		Mov Esi, TRUE
		Mov Edi, MF_ENABLED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_START_RECORDING, Edi
	Invoke EnableToolBarButton, 23, Esi
	.If bRecordingMacro
		Mov Esi, TRUE
		Mov Edi, MF_ENABLED
	.Else
		Xor Esi, Esi
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_STOP_RECORDING, Edi
	Invoke EnableToolBarButton, 24, Esi

	Mov Edx, lpMacroContent
	.If bRecordingMacro
@@:		Xor Esi, Esi
		Mov Edi, MF_GRAYED
	.Else
		Cmp DWord Ptr [Edx], 0
		Je @B
		Mov Esi, TRUE
		Mov Edi, MF_ENABLED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_PLAYBACK, Edi
	Invoke EnableToolBarButton, 25, Esi
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_RUN_MULTIPLE_TIMES, Edi
	Ret
EnableChangeMenus EndP

EnableSelChangeMenus Proc Private Uses Ebx Edi Esi
	Local lMin:LONG, lMax:LONG

	Invoke GetMenu, App.Main
	Mov Ebx, Eax
	Invoke SendMessage, hWndEditor, RSM_GETSELECTION, Addr lMin, Addr lMax
	Mov Eax, lMax
	Sub Eax, lMin
	.If Eax
		Mov Edi, MF_ENABLED
	.Else
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Mov Esi, Eax
	Invoke EnableToolBarButton, 8, Esi
	Invoke EnableToolBarButton, 9, Esi
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_CUT, Edi
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_COPY, Edi
	Invoke SendMessage, hWndEditor, EM_CANPASTE, CF_TEXT, 0
	.If Eax
		Mov Edi, MF_ENABLED
	.Else
		Mov Edi, MF_GRAYED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 10, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_PASTE, Edi
	Invoke SendMessage, hWndEditor, RSM_GETLASTPOSITION, 0, 0
	Mov Esi, Eax
	.If Eax == 0
		Mov Edi, MF_GRAYED
	.Else
		Mov Edi, MF_ENABLED
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_SELECT_ALL, Edi
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_LOCK, Edi
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_UNLOCK, Edi

	.If Esi == lMin
		Mov Edi, MF_GRAYED
		Xor Eax, Eax
	.Else
		Mov Edi, MF_ENABLED
		Mov Eax, TRUE
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 11, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_DELETE, Edi

	Invoke SendMessage, hWndEditor, RSM_GETPREVNEXTBOOKMARK, Addr lMin, Addr lMax
	.If lMax == (-1)
		Mov Edi, MF_GRAYED
		Xor Eax, Eax
	.Else
		Mov Edi, MF_ENABLED
		Mov Eax, TRUE
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 19, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_NEXT_BOOKMARK, Edi
	.If lMin == (-1)
		Mov Edi, MF_GRAYED
		Xor Eax, Eax
	.Else
		Mov Edi, MF_ENABLED
		Mov Eax, TRUE
	.EndIf
	Invoke EnableToolBarButton, 20, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_PREV_BOOKMARK, Edi
	.If lMin != (-1) || lMax != (-1)
@@:		Mov Edi, MF_ENABLED
		Mov Eax, TRUE
	.Else
		Invoke SendMessage, hWndEditor, RSM_ISCURRENTLINEBOOKMARKED, 0, 0
		Or Eax, Eax
		Jnz @B
		Mov Edi, MF_GRAYED
		Xor Eax, Eax
	.EndIf
	Or Edi, MF_BYCOMMAND
	Invoke EnableToolBarButton, 21, Eax
	Invoke EnableMenuItem, Ebx, IDM_EDITOR_CLEAR, Edi
	Ret
EnableSelChangeMenus EndP

EnableToolBarButton Proc Private lIndex:LONG, bEnable:BOOL
	Local rc:RECT

	Mov Edx, lIndex
	Sub Edx, 1
	Invoke RSSendMessage, hWndToolBar, TB_GETITEMRECT, Edx, Addr rc
	Invoke RSSendMessage, hWndToolBar, TB_ENABLEBUTTON, lIndex, bEnable
	Invoke InvalidateRect, hWndToolBar, Addr rc, FALSE
	Invoke RSSendMessage, hWndToolBar, WM_PAINT, 0, 0
	Ret
EnableToolBarButton EndP

FileChanged Proc Private Uses Esi
	Invoke SendMessage, hWndEditor, EM_GETMODIFY, 0, 0
	.If Eax
		Invoke GlobalAlloc, GPTR, MAX_PATH
		Mov Esi, Eax
		Invoke RSLoadString, App.Instance, IDS_TEXT_CHANGED, Esi, 255
		Invoke RSMessageBox, App.Main, Esi, App.Header, (MB_ICONQUESTION OR MB_YESNOCANCEL)
		Push Eax
		Invoke GlobalFree, Esi
		Pop Eax
		.If Eax == IDYES
			Invoke SetWaitCursor, App.Main
			Invoke RSSendMessage, App.Main, WM_COMMAND, IDM_EDITOR_SAVE, 0
			Invoke SetDefaultCursor
		.ElseIf Eax != IDNO
			Return TRUE
		.EndIf
		Xor Eax, Eax
	.EndIf
	Ret
FileChanged EndP

GetCommonDialogBox Proc Private bOpen:BOOL
	Push bOpen
	.If bAppUnicode
		Mov Eax, GetCommonDialogBoxW
	.Else
		Mov Eax, GetCommonDialogBoxA
	.EndIf
	Call Eax
	Ret
GetCommonDialogBox EndP

GetCommonDialogBoxA Proc Private bOpen:BOOL
	Local ofn:OPENFILENAME

	Invoke SetWaitCursor, App.Main
	Invoke RtlFillMemory, Addr ofn, SizeOf OPENFILENAME, 0
	Invoke GlobalAlloc, GPTR, (MAX_PATH * 4)
	Mov Esi, Eax
	Add Eax, MAX_PATH
	Mov Edi, Eax
	Add Eax, MAX_PATH
	Mov ofn.lpstrFile, Eax
	Add Eax, MAX_PATH
	Mov ofn.lpstrFilter, Eax
	Mov ofn.nMaxFile, MAX_PATH
	.If bOpen
		Mov Ecx, IDS_FILE_OPEN
	.Else
		.If bAppUnicode
			Mov Ecx, IDS_FILE_SAVE_NT
		.Else
			Mov Ecx, IDS_FILE_SAVE
		.EndIf
	.EndIf
	Invoke RSLoadString, App.Instance, Ecx, Eax, MAX_PATH
	Mov ofn.lStructSize, SizeOf OPENFILENAME
	Invoke lstrcpy, Edi, Addr Cfg.szLastPath
	Invoke FindCharRev, Edi, '\'
	.If Eax != (-1)
		Inc Eax
		Add Eax, Edi
		Push Eax
		Invoke lstrcmpi, Addr szFileName, Eax
		Pop Ecx
		.If (Eax == 0 || Byte Ptr [Ecx] == 0)
			Dec Ecx
			Mov Byte Ptr [Ecx], 0
		.EndIf
	.EndIf
	Invoke lstrlen, Edi
	.If (Eax < SDWord Ptr 3)
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLastPath, Edi
	.EndIf
	Mov ofn.lpstrInitialDir, Edi
	.If (!bOpen)
		Invoke lstrcpy, Esi, Addr szFileName
		Mov ofn.lpstrDefExt, TextAddr("txt")
	.EndIf
	Move ofn.hWndOwner, App.Main
	Move ofn.hInstance, App.Instance
	.If bOpen
		Mov Eax, lFilterOpen
		Mov ofn.nFilterIndex, 0
	.Else
		Mov Eax, lFilterSave
		Mov ofn.nFilterIndex, Eax
	.EndIf
	Mov ofn.lpstrFile, Esi
	Mov ofn.lpstrFileTitle, Offset szFileName
	Mov ofn.nMaxFile, MAX_PATH
	Mov ofn.nMaxFileTitle, MAX_PATH
	Mov ofn.Flags, (OFN_ENABLESIZING OR OFN_ENABLEHOOK OR OFN_EXPLORER OR OFN_HIDEREADONLY OR OFN_NOCHANGEDIR OR OFN_LONGNAMES)
	Mov ofn.lpfnHook, Offset OFNCommonDialogHookProc
	Invoke SetDefaultCursor
	.If bOpen
		Invoke lstrcpy, ofn.lpstrFile, TextStr("*.txt")
		Or ofn.Flags, (OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST)
		Invoke GetOpenFileName, Addr ofn
	.Else
		Or ofn.Flags, OFN_OVERWRITEPROMPT
		Invoke GetSaveFileName, Addr ofn
	.EndIf
	Push Eax
	.If Eax
		Mov Eax, ofn.nFilterIndex
		.If bOpen
			Mov lFilterOpen, Eax
		.Else
			Mov lFilterSave, Eax
		.EndIf
		Invoke lstrcpy, Addr Cfg.szLastPath, Esi
		Invoke FindCharRev, Addr Cfg.szLastPath, '\'
		.If Eax != (-1)
			Inc Eax
			Add Eax, Offset Cfg.szLastPath
			Mov Byte Ptr [Eax], 0
		.EndIf
		Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLastPath, Addr Cfg.szLastPath
	.EndIf
	Invoke GlobalFree, Esi
	Invoke SetDefaultCursor
	Pop Eax
	Ret
GetCommonDialogBoxA EndP

GetCommonDialogBoxW Proc Private bOpen:BOOL
	Local ofn:OPENFILENAME

	Invoke SetWaitCursor, App.Main
	Invoke RtlFillMemory, Addr ofn, SizeOf OPENFILENAME, 0
	Invoke GlobalAlloc, GPTR, (MAX_PATH * 8)
	Mov Esi, Eax
	Add Eax, (MAX_PATH * 2)
	Mov Edi, Eax
	Add Eax, (MAX_PATH * 2)
	Mov ofn.lpstrFile, Eax
	Add Eax, (MAX_PATH * 2)
	Mov ofn.lpstrFilter, Eax
	Mov ofn.nMaxFile, MAX_PATH
	.If bOpen
		Mov Ecx, IDS_FILE_OPEN
	.Else
		.If bAppUnicode
			Mov Ecx, IDS_FILE_SAVE_NT
		.Else
			Mov Ecx, IDS_FILE_SAVE
		.EndIf
	.EndIf
	Invoke RSLoadString, App.Instance, Ecx, Eax, MAX_PATH
	Mov ofn.lStructSize, SizeOf OPENFILENAME
	Invoke RSlstrcpy, Edi, Addr Cfg.szLastPath
	Invoke FindCharRev, Edi, '\'
	.If Eax != (-1)
		Inc Eax
		Shl Eax, 1
		Add Eax, Edi
		Push Eax
		Invoke RSlstrcmpi, Addr szFileName, Eax
		Pop Ecx
		.If (Eax == 0 || Word Ptr [Ecx] == 0)
			Sub Ecx, 2
			Mov Word Ptr [Ecx], 0
		.EndIf
	.EndIf
	Invoke RSlstrlen, Edi
	.If (Eax < SDWord Ptr 3)
		Invoke GetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLastPath, Edi
	.EndIf
	Mov ofn.lpstrInitialDir, Edi
	.If (!bOpen)
		Invoke RSlstrcpy, Esi, Addr szFileName
		Mov ofn.lpstrDefExt, TextAddrW("txt")
	.EndIf
	Move ofn.hWndOwner, App.Main
	Move ofn.hInstance, App.Instance
	.If bOpen
		Mov Eax, lFilterOpen
		Mov ofn.nFilterIndex, 0
	.Else
		Mov Eax, lFilterSave
		Mov ofn.nFilterIndex, Eax
	.EndIf
	Mov ofn.lpstrFile, Esi
	Mov ofn.lpstrFileTitle, Offset szFileName
	Mov ofn.nMaxFile, (MAX_PATH * 2)
	Mov ofn.nMaxFileTitle, (MAX_PATH * 2)
	Mov ofn.Flags, (OFN_ENABLESIZING OR OFN_ENABLEHOOK OR OFN_EXPLORER OR OFN_HIDEREADONLY OR OFN_NOCHANGEDIR OR OFN_LONGNAMES)
	Mov ofn.lpfnHook, Offset OFNCommonDialogHookProc
	Invoke SetDefaultCursor
	.If bOpen
		Invoke lstrcpy, ofn.lpstrFile, TextStr("*.txt")
		Or ofn.Flags, (OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST)
		Invoke GetOpenFileNameW, Addr ofn
	.Else
		Or ofn.Flags, OFN_OVERWRITEPROMPT
		Invoke GetSaveFileNameW, Addr ofn
	.EndIf
	Push Eax
	.If Eax
		Mov Eax, ofn.nFilterIndex
		.If bOpen
			Mov lFilterOpen, Eax
		.Else
			Mov lFilterSave, Eax
		.EndIf
		Invoke RSlstrcpy, Addr Cfg.szLastPath, Esi
		Invoke FindCharRev, Addr Cfg.szLastPath, '\'
		.If Eax != (-1)
			Inc Eax
			Shl Eax, 1
			Add Eax, Offset Cfg.szLastPath
			Mov Word Ptr [Eax], 0
		.EndIf
		Invoke SetRegistryValue, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szLastPath, Addr Cfg.szLastPath
	.EndIf
	Invoke GlobalFree, Esi
	Invoke SetDefaultCursor
	Pop Eax
	Ret
GetCommonDialogBoxW EndP

GetFileNameAndLoad Proc Private Uses Ebx Edi lpszPath:LPSTR
	Xor Eax, Eax
	Mov Ecx, lpszPath
	.If Ecx && Byte Ptr [Ecx]
		Lea Eax, Cfg.szLastPath
		Push Eax
		Push (MAX_PATH)
		.If bAppUnicode
			Call GetCurrentDirectoryW
		.Else
			Call GetCurrentDirectory
		.EndIf
		Invoke FindCharRev, lpszPath, '\'
		.If Eax == (-1)
			Invoke RSlstrcpy, Addr szFileName, lpszPath
		.Else
			Inc Eax
			.If bAppUnicode
				Shl Eax, 1
			.EndIf
			Mov Edi, Eax
			Add Edi, lpszPath
			Invoke RSlstrcpy, Addr szFileName, Edi
			Mov Word Ptr [Edi], 0
			Invoke RSlstrcpy, Addr Cfg.szLastPath, lpszPath
		.EndIf
		Invoke FileChanged
		.If (!Eax)
			Invoke LoadFile
			Invoke SetWindowPos, App.Main, NULL, 0, 0, 0, 0, (SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED)
			Invoke SetForegroundWindow, App.Main
			Mov Eax, TRUE
		.EndIf
	.EndIf
	Ret
GetFileNameAndLoad EndP

IsCharAlphaProc Proc Private lChar:LONG
	Push lChar
	.If bAppUnicode
		Mov Eax, IsCharAlphaProcW
	.Else
		Mov Eax, IsCharAlphaProcA
	.EndIf
	Call Eax
	Ret
IsCharAlphaProc EndP

IsCharAlphaProcA Proc Private lChar:LONG
	Mov Eax, lChar
	Cmp Al, 'A'
	Jnc @F
L2:	Xor Eax, Eax
	Ret
@@:	Cmp Al, '_'
	Je L4
	Cmp Al, '[' ; 'Z'+1
	Jc L4
	Cmp Al, 'a'
	Jc L2
	Cmp Al, '{' ;'z'+1
	Jc L4
	Cmp Al, ''
	Jc L2
L4:	Mov Eax, TRUE
	Ret
IsCharAlphaProcA EndP

IsCharAlphaProcW Proc Private lChar:LONG
	Mov Eax, lChar
	Cmp Ax, 'A'
	Jnc @F
L2:	Xor Eax, Eax
	Ret
@@:	Cmp Ax, '_'
	Je L4
	Cmp Ax, '[' ; 'Z'+1
	Jc L4
	Cmp Ax, 'a'
	Jc L2
	Cmp Ax, '{' ;'z'+1
	Jc L4
	Cmp Ax, ''
	Jc L2
L4:	Mov Eax, TRUE
	Ret
IsCharAlphaProcW EndP

LoadFile Proc Private Uses Esi
	Mov Eax, (MAX_PATH * 2)
	.If bAppUnicode
		Shl Eax, 1
	.EndIf
	Invoke GlobalAlloc, GPTR, Eax
	Mov Esi, Eax
	Invoke RSlstrcpy, Esi, Addr Cfg.szLastPath
	Invoke MakeFullPath, Esi, Addr szFileName
	Invoke SendMessage, hWndEditor, RSM_OPENFILE, 0, Esi
	Invoke GlobalFree, Esi
	Invoke SendMessage, hWndEditor, RSM_ISTEXTUNICODELE, 0, 0
	Mov bTextUnicode, Eax
	Invoke SendMessage, hWndEditor, RSM_GETTEXTFORMAT, 0, 0
	Mov lFilterSave, Eax
	Invoke SendMessage, hWndEditor, RSM_SETSELECTION, 0, 0
	Invoke SetAppCaption, FALSE
	Invoke EnableChangeMenus
	Invoke EnableSelChangeMenus
	Ret
LoadFile EndP

MakeFullPath Proc lpszPath:LPSTR, lpszFile:LPSTR
	Invoke RSlstrlen, lpszPath
	.If bAppUnicode
		Shl Eax, 1
	.EndIf
	Add Eax, lpszPath
	Cmp Eax, lpszPath
	Je @F
	.If bAppUnicode
		Cmp Word Ptr [Eax - 2], '\'
		Je @F
		Mov Word Ptr [Eax], '\'
		Add Eax, 2
	.Else
		Cmp Byte Ptr [Eax - 1], '\'
		Je @F
		Mov Byte Ptr [Eax], '\'
		Inc Eax
	.EndIf
	Mov Word Ptr [Eax], 0
@@:	Cmp lpszFile, NULL
	Je @F
	Push Eax
	Invoke RSlstrcpy, Eax, lpszFile
	Pop Eax
@@:	Ret
MakeFullPath EndP

OFNCommonDialogHookProc Proc Private Uses Edi Esi hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	Local rc:RECT, rc1:RECT

	.If uMsg == WM_INITDIALOG
		Invoke GetParent, hDlg
		Mov Esi, Eax
		Invoke GetWindowRect, Esi, Addr rc
		Invoke GetParent, Esi
		Mov Edx, Eax
		Invoke GetWindowRect, Edx, Addr rc1
		Mov Ecx, rc.right
		Sub Ecx, rc.left
		Mov Edx, rc.bottom
		Sub Edx, rc.top
		Mov Edi, rc1.right
		Sub Edi, rc1.left
		Shr Edi, 1
		Mov Eax, Ecx
		Shr Eax, 1
		Sub Edi, Eax
		Add Edi, rc1.left
		Push Edi
		Mov Edi, rc1.bottom
		Sub Edi, rc1.top
		Shr Edi, 1
		Mov Eax, Edx
		Shr Eax, 1
		Sub Edi, Eax
		Add Edi, rc1.top
		Pop Eax
		Invoke MoveWindow, Esi, Eax, Edi, Ecx, Edx, FALSE
		Return TRUE
	.ElseIf uMsg == WM_NOTIFY
		Mov Edi, lParam
		.If [Edi].NMHDR.code == (-601) ;CDN_INITDONE is bad defined in Windows.inc
			Invoke RedrawWindow, App.Main, NULL, NULL, (RDW_INVALIDATE OR RDW_UPDATENOW)
			Return TRUE
		.EndIf
	.EndIf
	Xor Eax, Eax
	Ret
OFNCommonDialogHookProc EndP

RSEditorWndProc Proc Uses Ebx Edi Esi hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_DROPFILES
		Invoke DropFiles, wParam
	.EndIf
	Invoke GetWindowLong, hWnd, GWL_USERDATA
	Invoke CallWindowProc, Eax, hWnd, uMsg, wParam, lParam
	Ret
RSEditorWndProc EndP

RunMacro Proc Private
	Local bEndOfFile:BOOL, lCount:LONG, lLine:LONG
	Local lLines:LONG, dwEventMask:DWord, msg:MSG

	.If hWndEditor != NULL && lpMacroContent != NULL
		Push Ebx
		Push Edi
		Push Esi
		Invoke RSSendMessage, hWndEditor, RSM_SETEVENTMASK, 0, 0
		Mov dwEventMask, Eax
		Invoke GetKeyboardState, Addr ssKeyboardState
		Invoke RSSendMessage, hWndEditor, RSM_GETLINECOUNT, 0, 0
		Mov lLines, Eax
		Invoke RSSendMessage, hWndEditor, RSM_GETCURRENTLINE, 0, 0
		Mov lLine, Eax
		Mov bEndOfFile, FALSE
		.If lMacroTimes == (-1) || SDWord Ptr lMacroTimes > 1
			.If lMacroTimes == (-1)
				Mov Eax, lLines
				Sub Eax, lLine
				Mov lMacroTimes, Eax
			.EndIf
			Mov bEndOfFile, TRUE
			Invoke RSSendMessage, hWndEditor, RSM_SETREDRAWFLAG, FALSE, 0
		.EndIf
		Mov lCount, 0
		Invoke SetFocus, hWndEditor
		Mov bPlayingMacro, TRUE
		Mov bTextNotFound, FALSE
		Mov Esi, lpMacroContent
		Cmp bSkipEmptyLines, FALSE
		Je L2
		Invoke RSSendMessage, hWndEditor, RSM_SKIPEMPTYLINE, 0, 0
L2:		.If hWndSearch
			Invoke RSSendMessage, hWndEditor, RSM_GETLINEINDEX, lLine, 0
			Invoke RSSendMessage, hWndSearch, EM_SETFIRSTPOSITION, 0, Eax
			Invoke RSSendMessage, hWndEditor, RSM_GETLASTPOSITION, 0, 0
			Invoke RSSendMessage, hWndSearch, EM_SETLASTPOSITION, 0, Eax
		.EndIf
		Mov Eax, DWord Ptr [Esi] ;hWnd
		Or Eax, Eax
		Jz @F
		Add Esi, SizeOf DWord
		Mov Ebx, DWord Ptr [Esi] ;uMsg
		Add Esi, SizeOf DWord
		Mov Edi, DWord Ptr [Esi] ;wParam
		Add Esi, SizeOf DWord
		Mov Edx, DWord Ptr [Esi] ;lParam
		Add Esi, SizeOf DWord
		Push Eax
		Push Edx
		Invoke SetKeyboardState, Esi
		Pop Edx
		Pop Eax
		Invoke ProcessMessages, Eax, Ebx, Edi, Edx
		Add Esi, 256
		Cmp bTextNotFound, FALSE
		Je L2
@@:		Inc lCount
		.If bSkipEmptyLines
			Invoke RSSendMessage, hWndEditor, RSM_SKIPEMPTYLINE, 0, 0
		.EndIf
		.If hWndSearch
			Invoke RSSendMessage, hWndEditor, RSM_GETLASTPOSITION, 0, 0
			Invoke RSSendMessage, hWndSearch, EM_SETLASTPOSITION, 0, Eax
		.EndIf
		.If lMacroTimes > SDWord Ptr 1
			Invoke RSSendMessage, hWndEditor, RSM_GETCURRENTLINE, 0, 0
			.If Eax < SDWord Ptr lLines
				.If (!bTextNotFound)
					Mov Esi, lpMacroContent
					Mov Eax, lCount
					Cmp Eax, lMacroTimes
					Jl L2
				.EndIf
			.EndIf
			.If bEndOfFile
				Invoke RSSendMessage, hWndEditor, RSM_SETREDRAWFLAG, TRUE, TRUE
			.EndIf
		.EndIf
		Mov bPlayingMacro, FALSE
		Mov lMacroTimes, 0
		Mov bTextNotFound, FALSE
		Invoke SetKeyboardState, Addr ssKeyboardState
@@:		Invoke PeekMessage, Addr msg, NULL, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE
		Or Eax, Eax
		Jnz @B
		Invoke RSSendMessage, hWndEditor, RSM_SETEVENTMASK, dwEventMask, 0
		Invoke EnableChangeMenus
		Invoke RSSendMessage, App.Main, RSM_UPDATEEDITFUNCTIONS, 0, 0
		Invoke SetStatusBar
		Pop Esi
		Pop Edi
		Pop Ebx
	.EndIf
	Ret
RunMacro EndP

RSRecordMacro Proc Private Uses Esi hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local lKeyState:LONG

	.If bRecordingMacro
		.If SDWord Ptr lMacroCount < (1048576 - 4)
			Mov Esi, lpMacroContent
			Add Esi, lMacroCount
			Mov Eax, hWnd
			Mov DWord Ptr [Esi], Eax
			Add Esi, SizeOf DWord
			Mov Eax, uMsg
			Mov DWord Ptr [Esi], Eax
			Add Esi, SizeOf DWord
			Mov Eax, wParam
			Mov DWord Ptr [Esi], Eax
			Add Esi, SizeOf DWord
			Mov Eax, lParam
			Mov DWord Ptr [Esi], Eax
			Add Esi, SizeOf DWord
			Invoke GetKeyboardState, Esi
			Add Esi, 256
			Mov DWord Ptr [Esi], 0
			Sub Esi, lpMacroContent
			Mov lMacroCount, Esi
		.Else
			Mov bRecordingMacro, FALSE
			Invoke RSSendMessage, hWnd, WM_COMMAND, IDM_EDITOR_STOP_RECORDING, 0
			Invoke RSLoadString, App.Instance, IDS_NO_MORE_MACRO_COMMANDS, lpszCommon, MAX_PATH
			Invoke RSMessageBox, hWnd, lpszCommon, App.Header, (MB_OK OR MB_ICONINFORMATION)
		.EndIf
	.EndIf
	Ret
RSRecordMacro EndP

SetAppCaption Proc Private Uses Esi bNoTitle:BOOL
	Invoke GlobalAlloc, GPTR, MAX_PATH * 2
	Mov Esi, Eax
	Invoke RSlstrcpy, Esi, Addr szFileName
	Invoke GetRightFormatText, lpszCommon, TextAddr(" - ")
	Invoke RSlstrcat, Esi, lpszCommon
	Invoke RSlstrcat, Esi, App.Header
	Invoke SetText, App.Main, Esi
	Mov Eax, bNoTitle
	Mov bUntitled, Eax
	Invoke GlobalFree, Esi
	Ret
SetAppCaption EndP

SetEncodingMenu Proc Private hSubMenu:HMENU
	Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_ANSI, (MF_BYCOMMAND OR MF_ENABLED)
	Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UNICODE_LE, (MF_BYCOMMAND OR MF_ENABLED)
	Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UNICODE_BE, (MF_BYCOMMAND OR MF_ENABLED)
	Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UTF8, (MF_BYCOMMAND OR MF_ENABLED)
	Invoke SendMessage, hWndEditor, RSM_GETTEXTFORMAT, 0, 0
	.If Eax == ANSI_TEXT
		Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_ANSI, (MF_BYCOMMAND OR MF_GRAYED)
	.ElseIf Eax == UNICODE_LE_TEXT
		Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UNICODE_LE, (MF_BYCOMMAND OR MF_GRAYED)
	.ElseIf Eax == UNICODE_BE_TEXT
		Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UNICODE_BE, (MF_BYCOMMAND OR MF_GRAYED)
	.ElseIf Eax == UTF_8_TEXT
		Invoke EnableMenuItem, hSubMenu, IDM_EDITOR_CONVERT_UTF8, (MF_BYCOMMAND OR MF_GRAYED)
	.EndIf
	Ret
SetEncodingMenu EndP

SetStatusBar Proc Private Uses Edi
	Local lLine:LONG, lColumn:LONG

	.If Cfg.bStatusbar
		Lea Edi, szBuffer
		Invoke SendMessage, hWndEditor, RSM_GETPOSITION, Addr lLine, Addr lColumn
		Invoke RSLoadString, App.Instance, IDS_LINE, Edi, MAX_PATH
		Invoke RSlstrlen, Edi
		.If bAppUnicode
			Shl Eax, 1
		.EndIf
		Add Edi, Eax
		.If bAppUnicode
			Mov Word Ptr [Edi], ' '
			Add Edi, 2
		.Else
			Mov Byte Ptr [Edi], ' '
			Inc Edi
		.EndIf
		Invoke String, lLine, Edi, ecDecimal
		Invoke RSlstrlen, Edi
		.If bAppUnicode
			Shl Eax, 1
		.EndIf
		Add Edi, Eax
		Invoke RSLoadString, App.Instance, IDS_COLUMN, Edi, MAX_PATH
		Invoke RSlstrlen, Edi
		.If bAppUnicode
			Shl Eax, 1
		.EndIf
		Add Edi, Eax
		.If bAppUnicode
			Mov Word Ptr [Edi], ' '
			Add Edi, 2
		.Else
			Mov Byte Ptr [Edi], ' '
			Inc Edi
		.EndIf
		Invoke String, lColumn, Edi, ecDecimal
		Mov Edx, SB_SETTEXT
		.If bAppUnicode
			Mov Edx, SB_SETTEXTW
		.EndIf
		Invoke RSSendMessage, hWndStatusBar, Edx, 255, Addr szBuffer
	.EndIf
	Ret
SetStatusBar EndP
